#ifndef __WebForm_H_
#define __WebForm_H_

struct WebFormParam {
	char *Name;
	unsigned char *Value;
	struct WebFormParam *Next;
};

/* Class for filling in WWW forms */
class WebForm {
  public:
    WebForm();
    ~WebForm();
    void Reset(void);
    int GetHTTPError(void);
    int SetURL(char *URL);
    int SetHost(char *Host, int Port=80);
    int SetUserAgent(char *UserAgent);
    int SetReferer(char *Referer);
    int SetCookie(char *Cookie);
    int SetURLParam(char *Name, char *Value);
    int SetPOSTParam(char *Name, char *Value);
    char *GetHTTPHeader(char *Name);
    int Fetch(void);
    int FindText(char *Text);
    void DebugMode(int on);
    char *FindValue(char *LeadText, char TrailChar);
  private:
    int Debug;                        /* 0=Debug off, 1=Debug on */
    char *HTMLPage;
    int HTMLPageLen;
    int HTTPError;
    char *URL;
    char *Host;
    char *Referer;
    char *Cookie;
    char *UserAgent;
    int Port;
    struct WebFormParam *URLParams;
    struct WebFormParam *POSTParams;
    struct WebFormParam *HTTPHeaders;
};

#endif /* __WebForm_H_ */
