/* vi:set cindent: */
#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "getopt.h"
#include <stdarg.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

#include "WebForm.h"

int debug;

int
sockprintf (int socket, char *format,...)
{
  va_list ap;
  char buf[10240];

  va_start (ap, format);
  vsprintf (buf, format, ap);
  va_end (ap);
  return write (socket, buf, strlen (buf));
}

char *packnumber(char *number)
{
    char *s1,*s2;
    
    s1 = s2 = number;
    while (*s1 != 0) {
	 if (*s1 != '-')
	     *s2++ = *s1;
	 s1++;
    }
    *s2 = 0;
    return number;
}

int
smssend (char *number, char *email, unsigned char *message)
{
  WebForm form;
  char *key;
  char *num, *prefix;
  char prefix2[5];
  int ntry;
  int goodhtml;
  int delay;
  char *str_delay;
 
  num = strdup(number);
  if (!num) {
      fprintf(stderr, "malloc: Not enough memory!\n");
      return -1;
  }
  
  packnumber(num);
  printf("Sending to %s\n", num);

  /* 0042060Xxxxyyy */ 
  if (!strncmp(num,"0042060",7) && strlen(num) == 14)
      prefix = num + 5; else
  /* +42060Xxxxyyy */ 
  if (!strncmp(num,"+42060",6) && strlen(num) == 13)
      prefix = num + 4; else
  /* 060Xxxxyyy */
  if (!strncmp(num,"060",3) && strlen(num) == 10)
      prefix = num + 1;
  else {
    fprintf(stderr,"Invalid phone number '%s'\n",num);
    return -1;
  }

  printf("Sending message to +420-60%c-%s... ",prefix[2], prefix+3);
  fflush(stdout);

  ntry = 0;
  key = 0;
  
  strcpy(prefix2, "060x");
  prefix2[3] = prefix[2];

  while (1)
    {
      ntry++;

      if (ntry > 10)
	  return -1;

      form.Reset();
      form.SetHost("sms.paegas.cz");
      form.SetURL("/cgi-bin/sms/wwwsms");
      form.SetReferer("http://sms.paegas.cz/cgi-bin/sms/wwwsms");
      form.SetUserAgent("Mozilla/4.0 (compatible; sms; Linux)");
      if (key) {
        form.SetURLParam("email",email);
        form.SetURLParam("mtype","1");
        form.SetURLParam("text",(char *)message);
        form.SetURLParam("submit","Odeslat");
        form.SetURLParam("cntr1","777");
        form.SetURLParam("cntr2","0");
        form.SetURLParam("submit","Odeslat");
        form.SetURLParam("key",key);
        form.SetURLParam("number",prefix+3);
        form.SetURLParam("prefix",prefix2);
      }
      form.Fetch();

        if (key)
	       free(key);
	  key = form.FindValue("name=key value=\"", '\"');
	    if (key == NULL)
		    return -1;
	    
#define LIMIT		"Zkuste to za "
	    
	    goodhtml = 0;

	    if (form.FindText("Zprva odeslna")) {
		printf("Message sent successfully.\n");
	        return 0;
	    }
	    
	    if (form.FindText("Zadejte daje")) {
		delay = 0;
	        goodhtml = 1;
	    }

	    if (form.FindText("Platnost stranky")) {
		delay = 0;
	        goodhtml = 1;
	    }
	    

	  /* Pekroen asov limit  - zkuste to za XX sekund. */
	  str_delay = form.FindValue("zkuste to za ",' ');
	  if (str_delay) {
	      delay = atoi(str_delay);
	      free(str_delay);
	      goodhtml = 1;
	  }


      if (!goodhtml) {
	  printf("\nWarning: bad HTML code, please contact the author.\n");
	  key[0] = 0;
      }
      
      if (ntry > 1 && delay){
	  struct timeval tv;

          if (debug)
	      printf("Sleeping %u seconds\n",delay);
	  else printf("[%u] ", delay);
	  fflush(stdout);

	  tv.tv_sec = delay;
	  tv.tv_usec = 0;
	  select(0, NULL, NULL, NULL, &tv);
      } else {
	  printf("* ");
	  fflush(stdout);
      }
      
    }
}

void usage(char *progname)
{
    printf("Usage: %s [-d] [-l] [-n email@address] [phone number(s)]\n"
	   "       %s -V\n"
	   "       %s -h\n"
	   "\n"
	   "Options:\n"
	   "    -d            Debug mode\n"
	   "    -h            Show this help screen\n"
	   "    -l            Line mode, for use with NNTP (not implemented)\n",
	   "    -n email      Send delivery notification via e-mail\n"
	   "    -V            Display version\n",
	   progname, progname, progname);
}

int main(int argc, char **argv)
{
    char *email;
    char *message;
    char line[0x100];
    char *phoneno;
    int havephone;
    char *progname;
    char ch;
    int errs;
    
    progname = argv[0];
    debug = 0;
    
    while ((ch = getopt(argc, argv, "Vhn:d"))!=-1) {
	switch(ch) {
	    case 'V':
		printf("Version 0.1 (compiled on " __DATE__ ")\n");
		break;
	    case 'h':
		usage(progname);
		exit(0);
 	    case 'n':
		email = optarg;
		break;
	    case 'l':
		break;
            case 'd':
		debug = 1;
		break;
	    default:
		fprintf(stderr,"Invalid option %c, try %s -h\n", ch, progname);
		exit(1);
	}
    }
    
    argc -= optind;
    argv += optind;
	
    havephone = argc!=0;

    email = 0;
    
    message = (char *)malloc(1024);
   
    if (!havephone) {
      printf("Enter phone number: ");
      phoneno = (char *)malloc(1024);
      fgets(phoneno, 1024, stdin);
      if (phoneno[strlen(phoneno)-1] == '\n')
	  phoneno[strlen(phoneno)-1] = 0;
    }

    if (isatty(STDIN_FILENO)) 
	printf("Enter your message, end with '.':\n");

    message[0] = 0;    
    while (1) {
	if (isatty(STDIN_FILENO)) {
           printf("> ");
	   fflush(stdout);
        }
	if (fgets(line,0x100,stdin) == NULL)
	    break;
	if (line[strlen(line)-1] == '\n')
	    line[strlen(line)-1] = 0;
	if (!strcmp(line,"."))
	    break;
	if (message[0] && strlen(message)<1023)
	   strcat(message," ");
	if (strlen(message)+strlen(line)<1024)
		strcat(message,line);
	else {
	    memcpy(message, line, 1023-strlen(message));
	    message[1023] = 0;
	    printf("Warning: Message too long, truncated\n");
	    break;
	}
    }
 
    errs = 0;   
    if (havephone) {
	while(argc--) {
            if ( smssend(argv[0], email, (unsigned char *)message) < 0)
		errs++;
	    argv++;
	}
    }else{
	if ( smssend(phoneno, email, (unsigned char *)message) < 0)
	     errs++;
    }
    
    if (errs) {
	fprintf(stderr, "Error(s), some messages were not send!\n");
	exit(1);
    }else {
	printf("Ok, all messages sent to SMS center.\n");
	exit(0);
    }
    
    return 0;
}
