/* vi:set cindent: */
#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "getopt.h"
#include <stdarg.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

#include "WebForm.h"

int debug;

int
sockprintf (int socket, char *format,...)
{
  va_list ap;
  char buf[10240];

  va_start (ap, format);
  vsprintf (buf, format, ap);
  va_end (ap);
  return write (socket, buf, strlen (buf));
}

char *packnumber(char *number)
{
    char *s1,*s2;
    
    s1 = s2 = number;
    while (*s1 != 0) {
	 if (*s1 != '-')
	     *s2++ = *s1;
	 s1++;
    }
    *s2 = 0;
    return number;
}

int
smssend (char *number, char *email, unsigned char *message, char *mynumber)
{
  WebForm form;
  char *key;
  char *num, *phoneno;
  int ntry;
  int goodhtml;
  int delay;
  char *str_delay;
  char *oprefix, prefix[5];
 
  num = strdup(number);
  if (!num) {
      fprintf(stderr, "malloc: Not enough memory!\n");
      return -1;
  }
  
  packnumber(num);

  /* 0042060Xxxxyyy */ 
  if (!strncmp(num,"00420",5) && strlen(num) == 14)
      { phoneno = num + 8; oprefix = num+5;}else
  /* +42060Xxxxyyy */ 
  if (!strncmp(num,"+420",4) && strlen(num) == 13)
      { phoneno = num + 7; oprefix = num+4;} else
  /* 060Xxxxyyy */
  if (!strncmp(num,"0608",4) && strlen(num) == 10)
     { phoneno = num + 4; oprefix = num+1;} 
  else {
    fprintf(stderr,"Invalid phone number '%s'\n",num);
    return -1;
  }

  prefix[0] = '0';
  prefix[1] = oprefix[0];
  prefix[2] = oprefix[1];
  prefix[3] = oprefix[2];
  prefix[4] = 0;

  if (strcmp(prefix,"0608") && strcmp(prefix,"0777")) {
    printf("Invalid prefix %s\n", prefix);
    return -1;
  }

  printf("Sending message to Oskar +420-%s-%s...",prefix+1,phoneno);
  fflush(stdout);

  key = 0;
  
  if (debug)
      form.DebugMode(1);
  
  form.Reset();
  form.SetHost("www.oskarmobil.cz");
  form.SetURL("/cz/sms/s_main.php3");
  form.SetReferer("http://www.oskarmobil.cz/");
  form.SetUserAgent("Mozilla/4.0 (compatible; sms; Unix)");
  form.Fetch();
  
  key = form.FindValue("name=\"ppp\" value=\"", '\"');
  if (key == NULL)
      return -1;
  
  if (debug)
    printf("Key = %s\n", key);

  form.Reset();
  form.SetHost("www.oskarmobil.cz");
  form.SetURL("/cz/sms/send.php3");
  form.SetReferer("http://www.oskarmobil.cz/.../oscar.php3");
  form.SetUserAgent("Mozilla/4.0 (compatible; sms; Unix)");
  form.SetURLParam("ppp",key);
  form.SetURLParam("predcisli",prefix);
  form.SetURLParam("number",phoneno);
  if (mynumber)
	  form.SetURLParam("mynumber", mynumber);
  form.SetURLParam("message",(char *)message);
  form.SetURLParam("char_in","0");
  form.SetURLParam("char_le","779");
  form.SetURLParam("submit","Odeslat zprvu");
  form.Fetch();
  
  free(key);

 goodhtml = 0;

	    if (form.FindText("location: error_successfull.htm")) {
		printf("Message sent successfully.\n");
	        return 0;
	    }
	    
	  printf("\nWarning: bad HTML code, please contact the author.\n");
	  return -1;
      
}

void usage(char *progname)
{
    printf("Usage: %s [-d] [-l] [-n email@address] [phone number(s)]\n"
	   "       %s -V\n"
	   "       %s -h\n"
	   "\n"
	   "Options:\n"
	   "    -d            Debug mode\n"
	   "    -h            Show this help screen\n"
	   "    -l            Line mode, for use with NNTP (not implemented)\n",
	   "    -n email      Send delivery notification via e-mail\n"
	   "    -V            Display version\n",
	   progname, progname, progname);
}

int main(int argc, char **argv)
{
    char *email;
    char *message;
    char line[0x100];
    char *phoneno;
    char *mynumber;
    int havephone;
    char *progname;
    char ch;
    int errs;
    
    progname = argv[0];
    debug = 0;
    mynumber = 0;
    
    while ((ch = getopt(argc, argv, "Vhn:dx:"))!=-1) {
	switch(ch) {
	    case 'V':
		printf("Version 0.1 (compiled on " __DATE__ ")\n");
		break;
	    case 'h':
		usage(progname);
		exit(0);
 	    case 'n':
		email = optarg;
		break;
	    case 'l':
		break;
            case 'd':
		debug = 1;
		break;
	    case 'x':
		    mynumber = optarg;
		    break;
	    default:
		fprintf(stderr,"Invalid option %c, try %s -h\n", ch, progname);
		exit(1);
	}
    }
    
    argc -= optind;
    argv += optind;
	
    havephone = argc!=0;

    email = 0;
    
    message = (char *)malloc(1024);
   
    if (!havephone) {
      printf("Enter phone number: ");
      phoneno = (char *)malloc(1024);
      fgets(phoneno, 1024, stdin);
      if (phoneno[strlen(phoneno)-1] == '\n')
	  phoneno[strlen(phoneno)-1] = 0;
    }

    if (isatty(STDIN_FILENO)) 
	printf("Enter your message, end with '.':\n");

    message[0] = 0;    
    while (1) {
	if (isatty(STDIN_FILENO)) {
           printf("> ");
	   fflush(stdout);
        }
	if (fgets(line,0x100,stdin) == NULL)
	    break;
	if (line[strlen(line)-1] == '\n')
	    line[strlen(line)-1] = 0;
	if (!strcmp(line,"."))
	    break;
	if (message[0] && strlen(message)<1023)
	   strcat(message," ");
	if (strlen(message)+strlen(line)<1024)
		strcat(message,line);
	else {
	    memcpy(message, line, 1023-strlen(message));
	    message[1023] = 0;
	    printf("Warning: Message too long, truncated\n");
	    break;
	}
    }
 
    errs = 0;   
    if (havephone) {
	while(argc--) {
            if ( smssend(argv[0], email, (unsigned char*)message,mynumber) < 0)
		errs++;
	    argv++;
	}
    }else{
	if ( smssend(phoneno, email, (unsigned char *)message, mynumber) < 0)
	     errs++;
    }
    
    if (errs) {
	fprintf(stderr, "Error(s), some messages were not send!\n");
	exit(1);
    }else {
	printf("Ok, all messages sent to SMS center.\n");
	exit(0);
    }
    
    return 0;
}
